MODULE SUEFFT_MOD
CONTAINS
SUBROUTINE SUEFFT

USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK, JPHOOK

USE TPM_DIM         ,ONLY : R
USE TPM_GEN         ,ONLY : NOUT, NPRINTLEV
USE TPM_DISTR       ,ONLY : D, MYSETW
USE TPM_GEOMETRY    ,ONLY : G
USE TPM_FFT         ,ONLY : T!, TB
!USE TPM_FFTC        ,ONLY : TC, INIT_PLANS_FFT
#ifdef WITH_FFTW
USE TPM_FFTW        ,ONLY : TW, INIT_PLANS_FFTW
#endif
USE TPM_FFTH      ,ONLY : TC, INIT_PLANS_FFT

!USE BLUESTEIN_MOD   ,ONLY : BLUESTEIN_INIT, FFTB_TYPE
!

USE TPMALD_FFT      ,ONLY : TALD
!

IMPLICIT NONE

INTEGER(KIND=JPIM) :: JGL,IGLG, ILATS
LOGICAL :: LLP1,LLP2
REAL(KIND=JPHOOK) :: ZHOOK_HANDLE

!     ------------------------------------------------------------------

IF (LHOOK) CALL DR_HOOK('SUEFFT_MOD:SUEFFT',0,ZHOOK_HANDLE)

IF(.NOT.D%LGRIDONLY) THEN
        
  LLP1 = NPRINTLEV>0
  LLP2 = NPRINTLEV>1
  IF(LLP1) WRITE(NOUT,*) '=== ENTER ROUTINE SUEFFT ==='

#ifdef WITH_FFTW
  IF(TW%LFFTW)THEN
    CALL INIT_PLANS_FFTW(MAX(R%NDLON+R%NNOEXTZL,R%NDGL+R%NNOEXTZG))
  ELSE
    NULLIFY(TW%FFTW_PLANS)
  ENDIF
#endif

  CALL INIT_PLANS_FFT(MAX(R%NDLON+R%NNOEXTZL,R%NDGL+R%NNOEXTZG))

  !IF(TALD%LFFT992)THEN
  !  ALLOCATE(TALD%TRIGSE(R%NDGL+R%NNOEXTZG))
  !  IF(LLP2)WRITE(NOUT,9) 'TALD%TRIGSE    ',SIZE(TALD%TRIGSE),SHAPE(TALD%TRIGSE)
  !  ALLOCATE(TALD%NFAXE(19))
  !  IF(LLP2)WRITE(NOUT,9) 'TALD%NFAXE    ',SIZE(TALD%NFAXE),SHAPE(TALD%NFAXE)
  !  CALL SET99(TALD%TRIGSE,TALD%NFAXE,R%NDGL+R%NNOEXTZG)
  !ENDIF

ENDIF

IF (LHOOK) CALL DR_HOOK('SUEFFT_MOD:SUEFFT',1,ZHOOK_HANDLE)

!     ------------------------------------------------------------------

9 FORMAT(1X,'ARRAY ',A10,' ALLOCATED ',8I8)

END SUBROUTINE SUEFFT
END MODULE SUEFFT_MOD
