PROGRAM TEST

! Author : ??
! Modified :
!      D. Paradis & R. El Khatib : 04-07-22 GRIBEX

USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK, JPHOOK
USE MPL_MODULE  ,ONLY : MPL_RECV, MPL_SEND, MPL_INIT, MPL_END, MPL_BARRIER, &
     &                  MPL_BUFFER_METHOD, MPL_MYRANK, MPL_NPROC
USE SET2PE_MOD      ,ONLY : SET2PE
USE ABORT_TRANS_MOD ,ONLY : ABORT_TRANS

IMPLICIT NONE

INTEGER(KIND=JPIM) :: I_NSMAX,I_NDGL,NPROC,NPRGPNS,NPRGPEW,NPRTRW,NPRTRV
INTEGER(KIND=JPIM) :: I_NDLON,I_NMSMAX
INTEGER(KIND=JPIM) :: I_NOUT,I_MYPROC,I_NSPECG,I_NSPEC2G,IFGATHG
INTEGER(KIND=JPIM) :: I_NFLEV
INTEGER(KIND=JPIM) :: JLEV,II,J,I_NFLEVG,JJ,ITAG,ILEN,JA,ISND
INTEGER(KIND=JPIM) :: I_NSPEC2,I_NGPTOTG,I_NGPTOT,I_NPROMA,I_NGPBLKS,I_MYSETV
INTEGER(KIND=JPIM) ,ALLOCATABLE :: I_NLOEN(:),ITO(:)
!rg
INTEGER(KIND=JPIM) ,ALLOCATABLE :: ISNAX(:),ISMAX(:),IILEV(:)
INTEGER(KIND=JPIM) :: I_NDGUX
REAL(KIND=JPRB) :: Z_EXWN,Z_EYWN
!rg
REAL(KIND=JPRB) , ALLOCATABLE :: ZSPEC(:,:),ZVOR(:,:),ZDIV(:,:)
REAL(KIND=JPRB) , ALLOCATABLE :: ZSPECG(:,:),ZSPEC2(:,:),ZNORM(:)
REAL(KIND=JPRB) , ALLOCATABLE :: ZNORM1T(:),ZNORM2T(:)
REAL(KIND=JPRB) , ALLOCATABLE :: ZNORM1D(:),ZNORM2D(:)
REAL(KIND=JPRB) , ALLOCATABLE :: ZNORM1V(:),ZNORM2V(:),ZSEND(:)
REAL(KIND=JPRB) , ALLOCATABLE :: ZG(:,:,:),ZGG(:,:),ZVORG(:,:),ZDIVG(:,:)
REAL(KIND=JPRB) , ALLOCATABLE :: ZMEANU(:),ZMEANV(:),ZMEANUG(:),ZMEANVG(:)
REAL(KIND=JPRB) , ALLOCATABLE :: ZZMEANUVG(:,:),ZZMEANUV(:)
INTEGER(KIND=JPIM) :: IFROM(1000),IVSET(1000),IBSET

CHARACTER (LEN = 6) ::  CLNAME
CHARACTER (LEN = 10) ::  CLNAME1

CHARACTER(100):: CL_CFD
INTEGER(KIND=JPIM) :: I_NUFD,I_NBI,IREP,I,IOFF
LOGICAL :: LSPLIT , LMPOFF
INTEGER(KIND=JPIM),PARAMETER :: I_NBRART=3
INTEGER(KIND=JPIM),PARAMETER :: I_DIM1=512,I_DIM2=512
INTEGER(KIND=JPIM),PARAMETER :: DIM=I_DIM1*I_DIM2
CHARACTER(16) :: CL_CNMCA
CHARACTER(6),DIMENSION(1:I_NBRART) :: CL_CPREF
INTEGER(KIND=JPIM) :: ILEV
CHARACTER(16),DIMENSION(1:I_NBRART) :: CL_CVARFA
INTEGER(KIND=JPIM) :: ITYPTR,ITRUNC
REAL(KIND=JPRB) :: ZSLAPO,ZCLOPO,ZSLOPO,ZCODIL,Z_VP00
INTEGER(KIND=JPIM),ALLOCATABLE :: INLOPA(:)
INTEGER(KIND=JPIM),ALLOCATABLE :: INZOPA(:)
INTEGER(KIND=JPIM),ALLOCATABLE :: I_ZGEOM(:)
REAL(KIND=JPRB),ALLOCATABLE ::Z_VALH(:),Z_VBH(:)
REAL(KIND=JPRB),ALLOCATABLE :: Z_DATA(:,:,:)
REAL(KIND=JPRB),ALLOCATABLE :: Z_DATAG(:)
INTEGER(KIND=JPIM) :: JC
LOGICAL :: LL_LDGARD
INTEGER(KIND=JPIM) :: JM,JN,ISP,IFTM,ISP0,ISP1,ISP2,ISP3
REAL(KIND=JPRB),ALLOCATABLE :: Z_PSPFILE(:,:),Z_PSPBUF(:,:)
REAL(KIND=JPRB),ALLOCATABLE :: ZSPU(:,:),ZSPV(:,:)
REAL(KIND=JPRB),ALLOCATABLE :: ZSPDIV(:,:),ZSPVOR(:,:)
INTEGER(KIND=JPIM) ,ALLOCATABLE :: I_NDIM0G1(:)
REAL(KIND=JPRB) :: ZN,ZM
!REAL_B,ALLOCATABLE :: zbuf_data(:,:,:)
!REAL_B,ALLOCATABLE :: zbuf_data(:)
!REAL_B,ALLOCATABLE :: zbufr_data(:)
!REAL_B,ALLOCATABLE :: zbufr_data(:)
INTEGER(KIND=JPIM) :: JPROC
INTEGER(KIND=JPIM) ,ALLOCATABLE :: I_NPRCIDS(:)
REAL(KIND=JPHOOK) :: ZHOOK_HANDLE
INTEGER(KIND=JPIM) :: INBITS, ISTRON, IPUILA
INTEGER(KIND=JPIM), ALLOCATABLE :: INGRIB(:,:)
LOGICAL   :: LLEXIST
LOGICAL   :: LLCOSP=.TRUE.
!*********************************************************************

!NAMELIST/NAMTEST/NPRGPNS,NPRTRW,NPROC,NPRGPEW,NPRTRV,LSPLIT,LMPOFF

#include "setup_trans0.h"
#include "esetup_trans.h"
#include "einv_trans.h"
#include "edir_trans.h"
#include "edist_spec.h"
#include "egath_spec.h"
#include "egath_grid.h"
#include "etrans_inq.h"
#include "especnorm.h"

!***********************************************************************

LMPOFF=.FALSE.

IF( LMPOFF ) THEN
	NPROC=1
	NPRGPNS=1
	NPRGPEW=1
	NPRTRW=1
	NPRTRV=1
	LSPLIT=.FALSE.
  I_NOUT = 6
  WRITE(I_NOUT,*)'voila le fichier de sortie'
  I_MYPROC=1
ELSE
  
  !READ(4,NAMTEST)

  CALL MPL_INIT

  NPROC=MPL_NPROC()
  NPRGPNS=NPROC
  NPRGPEW=1
  NPRTRW=NPROC
  NPRTRV=1
  LSPLIT=.FALSE.
  
  I_MYPROC = MPL_MYRANK()
  WRITE(*,*) "i am on proc no ",I_MYPROC
  I_NOUT = 20+I_MYPROC
  WRITE(CLNAME,'(a,i2.2)') 'out.',I_MYPROC
  OPEN(I_NOUT,FILE=CLNAME)
  ALLOCATE(I_NPRCIDS(NPROC))
  DO JPROC=1,NPROC
    I_NPRCIDS(JPROC)=JPROC
  ENDDO
  
  CALL MPL_BUFFER_METHOD(KMP_TYPE=2,KMBX_SIZE=800000,KPROCIDS=I_NPRCIDS)

ENDIF
I_MYSETV=MOD(I_MYPROC-1,NPRTRV)+1
WRITE(I_NOUT,*) 'namelist finished'
call flush(I_NOUT)
!***********************************************************************
IF (LHOOK) CALL DR_HOOK('TEST',0,ZHOOK_HANDLE)
!**********************************
I_NPROMA=8
ITAG=1
CL_CFD='inputfile'
I_NUFD=97
CL_CNMCA='CADRE.STANDARD0 '

ALLOCATE(INLOPA(I_DIM1))
ALLOCATE(INZOPA(I_DIM2))
ALLOCATE(I_ZGEOM(I_DIM1))
ALLOCATE(Z_VALH(I_DIM1))
ALLOCATE(Z_VBH(I_DIM1))

! manual settings
ITRUNC=2  ! NSMAX
ITYPTR=3  ! NMSMAX
INLOPA(6)=6  ! NDGUX==NLAT
I_NDGL=6     ! NLAT
I_NDLON=8    ! NLON

I_NFLEVG=5
I_NDGUX=INLOPA(6)
CL_CPREF(1)='S'
CL_CPREF(2)='S'
CL_CPREF(3)='S'
CL_CVARFA(1)='WIND.U.PHYS     '
CL_CVARFA(2)='WIND.V.PHYS     '
CL_CVARFA(3)='TEMPERATURE     '
ALLOCATE(Z_DATA(DIM,I_NFLEVG,I_NBRART))
ALLOCATE(INGRIB(I_NFLEVG,I_NBRART))
Z_DATA(:,:,:)=123.456
call flush(I_NOUT)
DEALLOCATE(INLOPA)
DEALLOCATE(INZOPA)
DEALLOCATE(I_ZGEOM)
DEALLOCATE(Z_VALH)
DEALLOCATE(Z_VBH)
!**********************************
I_NSMAX=ITRUNC
I_NMSMAX=ABS(ITYPTR)
WRITE(I_NOUT,*) 'I_NSMAX=',I_NSMAX
WRITE(I_NOUT,*) 'I_NMSMAX=',I_NMSMAX
ALLOCATE(ISNAX(0:I_NMSMAX))
ALLOCATE(ISMAX(0:I_NSMAX))
CALL ELLIPS(I_NSMAX,I_NMSMAX,ISNAX,ISMAX)
WRITE(I_NOUT,*) 'definition of ellips:'
WRITE(I_NOUT,*) 'isnax:',ISNAX
WRITE(I_NOUT,*) 'ismax:',ISMAX
call flush(I_NOUT)
!**********************************
I_NSPECG=0
DO J=0,I_NMSMAX
  I_NSPECG=I_NSPECG+2*(ISNAX(J)+1)
ENDDO
WRITE(I_NOUT,*) 'I_NSPECG=',I_NSPECG
I_NSPEC2G=I_NSPECG*2
WRITE(I_NOUT,*) 'I_NSPEC2G=',I_NSPEC2G
call flush(I_NOUT)
!*************************************
ALLOCATE(I_NLOEN(I_NDGL))
I_NLOEN(:) = I_NDLON
CALL SETUP_TRANS0(KPROMATR=4,KOUT=I_NOUT,KERR=0,KPRINTLEV=2,KMAX_RESOL=2,&
 & KPRGPNS=NPRGPNS,KPRGPEW=NPRGPEW,KPRTRW=NPRTRW)
WRITE(I_NOUT,*) I_MYPROC,'after setup_trans0'

Z_EXWN=0.3926377E-05
Z_EYWN=0.5453301E-05
CALL ESETUP_TRANS(KMSMAX=I_NMSMAX,KSMAX=I_NSMAX,KDGL=I_NDGL,KDGUX=I_NDGUX, &
 & KLOEN=I_NLOEN,LDSPLIT=LSPLIT,PEXWN=Z_EXWN,PEYWN=Z_EYWN)
WRITE(0,*) I_MYPROC,'after esetup_trans'
CALL ETRANS_INQ(KSPEC2=I_NSPEC2,KGPTOT=I_NGPTOT,KGPTOTG=I_NGPTOTG)
WRITE(0,*) 'I_NGPTOTG=',I_NGPTOTG
I_NGPBLKS= (I_NGPTOT-1)/I_NPROMA+1
WRITE(I_NOUT,*) 'I_NGPBLKS=',I_NGPBLKS
WRITE(I_NOUT,*) 'I_NSPEC2=',I_NSPEC2,' I_NGPTOT=',I_NGPTOT
WRITE(0,*) 'I_NSPEC2=',I_NSPEC2,' I_NGPTOT=',I_NGPTOT,'on proc ',I_MYPROC
WRITE(I_NOUT,*) 'setup finished'
CALL FLUSH(I_NOUT)
!********************************************

!****************************************
ALLOCATE(ZSPU(I_NFLEVG,I_NSPEC2G))
ALLOCATE(ZSPV(I_NFLEVG,I_NSPEC2G))
ALLOCATE(ZSPDIV(I_NFLEVG,I_NSPEC2G))
ALLOCATE(ZSPVOR(I_NFLEVG,I_NSPEC2G))
DO JLEV=1,I_NFLEVG
  DO I=1,I_NSPEC2G
    ZSPU(JLEV,I)=Z_DATA(I,JLEV,1)
    ZSPV(JLEV,I)=Z_DATA(I,JLEV,2)
  ENDDO
ENDDO
DO JLEV=1,I_NFLEVG
  II=0
  DO JN=0,I_NSMAX
    DO JM=0,ISMAX(JN)
      II=II+1
      ISP0=II
      ISP1=II+1
      ISP2=II+2
      ISP3=II+3
      ZN=REAL(JN)
      ZM=REAL(JM)
      ZSPDIV(JLEV,II)=-ZN*Z_EYWN*ZSPV(JLEV,ISP1)-ZM*Z_EXWN*ZSPU(JLEV,ISP2)
      ZSPVOR(JLEV,II)=ZN*Z_EYWN*ZSPU(JLEV,ISP1)-ZM*Z_EXWN*ZSPV(JLEV,ISP2)
      II=II+1
      ZSPDIV(JLEV,II)=ZN*Z_EYWN*ZSPV(JLEV,ISP0)-ZM*Z_EXWN*ZSPU(JLEV,ISP3)
      ZSPVOR(JLEV,II)=-ZN*Z_EYWN*ZSPU(JLEV,ISP0)-ZM*Z_EXWN*ZSPV(JLEV,ISP3)
      II=II+1
      ZSPDIV(JLEV,II)=-ZN*Z_EYWN*ZSPV(JLEV,ISP3)+ZM*Z_EXWN*ZSPU(JLEV,ISP0)
      ZSPVOR(JLEV,II)=ZN*Z_EYWN*ZSPU(JLEV,ISP3)+ZM*Z_EXWN*ZSPV(JLEV,ISP0)
      II=II+1
      ZSPDIV(JLEV,II)=ZN*Z_EYWN*ZSPV(JLEV,ISP2)+ZM*Z_EXWN*ZSPU(JLEV,ISP1)
      ZSPVOR(JLEV,II)=-ZN*Z_EYWN*ZSPU(JLEV,ISP2)+ZM*Z_EXWN*ZSPV(JLEV,ISP1)
    ENDDO
  ENDDO
ENDDO
WRITE(I_NOUT,*) 'Computing of divergence and vorticity finished'
DO JLEV=1,I_NFLEVG
  DO I=1,I_NSPEC2G
    Z_DATA(I,JLEV,1)=ZSPVOR(JLEV,I)
    Z_DATA(I,JLEV,2)=ZSPDIV(JLEV,I)
  ENDDO
ENDDO
!**************************************
ALLOCATE(ZMEANUG(I_NFLEVG))
ALLOCATE(ZMEANVG(I_NFLEVG))
ZMEANUG(1:I_NFLEVG)=ZSPU(1:I_NFLEVG,1)
ZMEANVG(1:I_NFLEVG)=ZSPV(1:I_NFLEVG,1)
!**************************************

!*******************************************
ALLOCATE(I_NDIM0G1(0:I_NMSMAX))
CALL ETRANS_INQ(KDIM0G=I_NDIM0G1)
WRITE(I_NOUT,*) 'I_NDIM0G1: ',I_NDIM0G1
! Rearrange spectral data structure (see espareord)
ALLOCATE(Z_PSPFILE(I_NFLEVG,I_NSPEC2G))
ALLOCATE(Z_PSPBUF(I_NFLEVG,I_NSPEC2G))
! IF (I_MYPROC == 1) THEN
  ! OPEN(UNIT=17,FILE='avant.glob.nonreorg')
  ! DO J=1,I_NSPEC2G
    ! WRITE(17,*) Z_DATA(J,1,3)
  ! ENDDO
  ! CLOSE(17)
! ENDIF
DO JC=1,3
  DO JLEV=1,I_NFLEVG
    IF (.NOT.(INGRIB(JLEV,JC)==-1 .OR. INGRIB(JLEV,JC)==3)) THEN
      II=0
      DO JN=0,I_NSMAX
        IOFF=0
        DO JM=0,ISMAX(JN)
          DO IFTM=1,4
            ISP=IOFF+4*JN+IFTM
            II=II+1
            Z_PSPFILE(JLEV,II)=Z_DATA(II,JLEV,JC)
            Z_PSPBUF(JLEV,ISP)=Z_PSPFILE(JLEV,II)
          ENDDO
          IOFF=IOFF+4*(ISNAX(JM)+1)
        ENDDO
      ENDDO
      Z_DATA(1:I_NSPEC2G,JLEV,JC)=Z_PSPBUF(JLEV,1:I_NSPEC2G)
    ENDIF
  ENDDO
ENDDO

! IF (I_MYPROC == 1) THEN
  ! OPEN(UNIT=17,FILE='avant.glob')
  ! DO J=1,I_NSPEC2G
    ! WRITE(17,*) Z_DATA(J,1,3)
  ! ENDDO
  ! CLOSE(17)
! ENDIF
DEALLOCATE(Z_PSPFILE)
DEALLOCATE(Z_PSPBUF)
WRITE(I_NOUT,*) 'reorganisation finished'
CALL FLUSH(I_NOUT)
!*******************************************
ALLOCATE(ZSPECG(I_NFLEVG,I_NSPEC2G))
ALLOCATE(ZVORG(I_NFLEVG,I_NSPEC2G))
ALLOCATE(ZDIVG(I_NFLEVG,I_NSPEC2G))
DO J=1,I_NFLEVG
  DO I=1,I_NSPEC2G
    ZVORG(J,I)=Z_DATA(I,J,1)
    ZDIVG(J,I)=Z_DATA(I,J,2)
    ZSPECG(J,I)=Z_DATA(I,J,3)
  ENDDO
ENDDO
!*************************************
I_NFLEV=0
DO J=1,I_NFLEVG
  IVSET(J)=MOD(J,NPRTRV)+1
  IF(IVSET(J) == I_MYSETV) I_NFLEV=I_NFLEV+1
ENDDO
WRITE(0,*) 'I_NFLEV on ',I_MYPROC,I_NFLEV
WRITE(I_NOUT,*)' I_NFLEV=',I_NFLEV
ALLOCATE(ZSPEC(I_NFLEV,I_NSPEC2))
ALLOCATE(ZSPEC2(I_NFLEV,I_NSPEC2))
ALLOCATE(ZVOR(I_NFLEV,I_NSPEC2))
ALLOCATE(ZDIV(I_NFLEV,I_NSPEC2))
IFROM(1:I_NFLEVG)=1
ZSPEC=300.0
WRITE(0,*) I_MYPROC,' before edist_spec'
CALL EDIST_SPEC(PSPECG=ZSPECG,KFDISTG=I_NFLEVG,KFROM=IFROM,PSPEC=ZSPEC,KVSET=IVSET)
WRITE(0,*) I_MYPROC,' after edist_spec 1'
CALL EDIST_SPEC(PSPECG=ZVORG,KFDISTG=I_NFLEVG,KFROM=IFROM,PSPEC=ZVOR,KVSET=IVSET)
WRITE(0,*) I_MYPROC,' after edist_spec 2'
CALL EDIST_SPEC(PSPECG=ZDIVG,KFDISTG=I_NFLEVG,KFROM=IFROM,PSPEC=ZDIV,KVSET=IVSET)
WRITE(I_NOUT,*) 'distr finished'
! distribution of mean wind along vertical
ALLOCATE(ZMEANU(I_NFLEV))
ALLOCATE(ZMEANV(I_NFLEV))
IF (NPRTRV>1) THEN
  ALLOCATE(ZZMEANUVG(NPROC,2*I_NFLEVG))
  ALLOCATE(ZZMEANUV(2*I_NFLEV))
  ALLOCATE(IILEV(NPROC))
  IILEV(1:NPROC)=0
  DO J=1,I_NFLEVG
    IBSET=IVSET(J)
    DO JA=1,NPRTRW
      CALL SET2PE(ISND,0,0,JA,IBSET)
      ISND=I_NPRCIDS(ISND)
      IILEV(ISND)=IILEV(ISND)+1
      ZZMEANUVG(ISND,2*(IILEV(ISND)-1)+1)=ZMEANUG(J)
      ZZMEANUVG(ISND,2*IILEV(ISND))=ZMEANVG(J)
    ENDDO
  ENDDO
  IF (I_MYPROC == 1) THEN
    DO JPROC=1,NPROC
      DO JLEV=1,I_NFLEVG
      ENDDO
    ENDDO
  ENDIF
  IF (I_MYPROC == 1) THEN
!     plain copy
    IF (I_NFLEV /= IILEV(1)) CALL ABORT_TRANS('lengths are not the same on 1')
    DO J=1,I_NFLEV
      ZMEANU(J)=ZZMEANUVG(1,2*(J-1)+1)
      ZMEANV(J)=ZZMEANUVG(1,2*J)
    ENDDO
    ALLOCATE(ZSEND(2*I_NFLEVG))
    DO JPROC=2,NPROC
      ZSEND(1:2*IILEV(JPROC))=ZZMEANUVG(JPROC,1:2*IILEV(JPROC))
      ITAG=300000+I_NFLEVG*NPROC+JPROC
      CALL MPL_SEND(ZSEND(1:2*IILEV(JPROC)),KDEST=JPROC,KTAG=ITAG,CDSTRING='main:')
    ENDDO
  ELSE
    ITAG=300000+I_NFLEVG*NPROC+I_MYPROC
    CALL MPL_RECV(ZZMEANUV(1:2*I_NFLEV),KSOURCE=1,KTAG=ITAG,KOUNT=ILEN,CDSTRING='main:')
    IF (ILEN /= 2*I_NFLEV) CALL ABORT_TRANS('main: RECV INVALID RECEIVE MESSAGE LENGTH')
    DO J=1,I_NFLEV
      ZMEANU(J)=ZZMEANUV(2*(J-1)+1)
      ZMEANV(J)=ZZMEANUV(2*J)
    ENDDO
  ENDIF

ELSE
  ZMEANU(:)=ZMEANUG(:)
  ZMEANV(:)=ZMEANVG(:)
ENDIF
!*******************************************
WRITE(I_NOUT,*) 'ivset(1:I_NFLEVG)=',IVSET(1:I_NFLEVG)
WRITE(0,*) I_MYPROC,' after edist_spec 3'
CALL FLUSH(I_NOUT)
!*******************************************
ALLOCATE(ZNORM(I_NFLEVG))
ALLOCATE(ZNORM1T(I_NFLEVG))
ALLOCATE(ZNORM1V(I_NFLEVG))
ALLOCATE(ZNORM1D(I_NFLEVG))
ALLOCATE(ZNORM2T(I_NFLEVG))
ALLOCATE(ZNORM2V(I_NFLEVG))
ALLOCATE(ZNORM2D(I_NFLEVG))
WRITE(0,*) I_MYPROC,' after znorm allocation'
CALL ESPECNORM(PSPEC=ZSPEC,KVSET=IVSET(1:I_NFLEVG),PNORM=ZNORM)
WRITE(0,*) I_MYPROC,' after especnorm 1'
WRITE(I_NOUT,*) 'znorm_avant t '
DO J=1,I_NFLEVG
  ZNORM1T(J)=ZNORM(J)
  IF (I_MYPROC == 1) WRITE(I_NOUT,*) '           ',J,'   ',ZNORM(J)
ENDDO
!***********************************************
CALL ESPECNORM(PSPEC=ZVOR,KVSET=IVSET(1:I_NFLEVG),PNORM=ZNORM)
! WRITE(0,*) I_MYPROC,' after especnorm 2'
! WRITE(I_NOUT,*) 'znorm_avant vor '
! DO J=1,I_NFLEVG
  ! ZNORM1V(J)=ZNORM(J)
  ! IF (I_MYPROC == 1) WRITE(I_NOUT,*) '            ',J,'   ',ZNORM(J)
! ENDDO
!***********************************************
CALL ESPECNORM(PSPEC=ZDIV,KVSET=IVSET(1:I_NFLEVG),PNORM=ZNORM)
! WRITE(0,*) I_MYPROC,' after especnorm 3'
! WRITE(I_NOUT,*) 'znorm_avant div '
! DO J=1,I_NFLEVG
  ! ZNORM1D(J)=ZNORM(J)
  ! IF (I_MYPROC == 1) WRITE(I_NOUT,*) '           ',J,'    ',ZNORM(J)
! ENDDO
!***********************************************
CALL FLUSH(I_NOUT)
ALLOCATE(ZG(I_NPROMA,3*I_NFLEVG,I_NGPBLKS))
ALLOCATE(ZGG(I_NGPTOTG,3*I_NFLEVG))
ALLOCATE(ITO(3*I_NFLEVG))
ZG=0.0
!write(nout,*) 'temperature avant dirtr'
!write(nout,*) zspec(1,1:10)
!write(nout,*) 'divergence avant dirtr'
!write(nout,*) zdiv(1,1:10)
!*****************************************************
!**************************************************************
! IF ( NPROC>1 ) THEN
  ! WRITE(CLNAME1,'(a,i2.2)') 'avant.',I_MYPROC
! ELSE
  ! CLNAME1='avant.1'
! ENDIF
! OPEN(UNIT=97,FILE=CLNAME1,FORM='formatted')
! DO J=1,I_NSPEC2
  ! WRITE(97,FMT='(3(E20.8,2x))')ZSPEC(1,J),ZVOR(1,J),ZDIV(1,J)
! ENDDO
! CLOSE(97)
!**************************************************************

CALL EINV_TRANS(PSPVOR=ZVOR,PSPDIV=ZDIV,PSPSCALAR=ZSPEC,PGP=ZG,PMEANU=ZMEANU,PMEANV=ZMEANV,&
 & KPROMA=I_NPROMA,KVSETSC=IVSET(1:I_NFLEVG), KVSETUV=IVSET(1:I_NFLEVG))

ITO(:)=1
IFGATHG=3*I_NFLEVG
CALL EGATH_GRID(PGPG=ZGG,KPROMA=I_NPROMA,KFGATHG=IFGATHG,KTO=ITO,PGP=ZG)


!**************************************************************


IF (I_MYPROC == 1) THEN
  WRITE(0,*) ' after einv_trans'
  DO J=1,3*I_NFLEVG
    WRITE(I_NOUT,*) (ZGG(JJ,J),JJ=1,I_NGPTOTG,1000)
    WRITE(I_NOUT,*) '*************************************'
    CALL FLUSH(I_NOUT)
  ENDDO
  CALL FLUSH(I_NOUT)
ENDIF
!************************************************************
ZSPEC=0.0
ZVOR=0.0
ZDIV=0.0
CALL EDIR_TRANS(PSPVOR=ZVOR,PSPDIV=ZDIV,PSPSCALAR=ZSPEC,PGP=ZG,PMEANU=ZMEANU,PMEANV=ZMEANV,&
 & KPROMA=I_NPROMA,KVSETSC=IVSET(1:I_NFLEVG), KVSETUV=IVSET(1:I_NFLEVG))
!**************************************************************

WRITE(I_NOUT,*) 'temperature after dirtr'
WRITE(I_NOUT,*) ZSPEC(1,1:10)

!**************************************************************
!**************************************************************
! IF ( NPROC>1 ) THEN
  ! WRITE(CLNAME1,'(a,i2.2)') 'apres.',I_MYPROC
! ELSE
  ! CLNAME1='apres.1'
! ENDIF
! OPEN(UNIT=97,FILE=CLNAME1,FORM='formatted')
! DO J=1,I_NSPEC2
  ! WRITE(97,FMT='(3(E20.8,2x))')ZSPEC(1,J),ZVOR(1,J),ZDIV(1,J)
! ENDDO
! CLOSE(97)
!**************************************************************
!*************************************************************
CALL ESPECNORM(PSPEC=ZSPEC,KVSET=IVSET(1:I_NFLEVG),PNORM=ZNORM)
! WRITE(I_NOUT,*) 'znorm_apres t'
! DO J=1,I_NFLEVG
  ! ZNORM2T(J)=ZNORM(J)
  ! WRITE(I_NOUT,*) '     ',J,'   ',ZNORM(J)
! ENDDO
! CALL FLUSH(I_NOUT)
!**************************************
CALL ESPECNORM(PSPEC=ZVOR,KVSET=IVSET(1:I_NFLEVG),PNORM=ZNORM)
! WRITE(I_NOUT,*) 'znorm_apres vor'
! DO J=1,I_NFLEVG
  ! ZNORM2V(J)=ZNORM(J)
  ! WRITE(I_NOUT,*) '     ',J,'   ',ZNORM(J)
! ENDDO
!**************************************
CALL ESPECNORM(PSPEC=ZDIV,KVSET=IVSET(1:I_NFLEVG),PNORM=ZNORM)
! IF(I_MYPROC == 1) THEN
  ! WRITE(I_NOUT,*) 'znorm_apres div'
  ! DO J=1,I_NFLEVG
    ! ZNORM2D(J)=ZNORM(J)
    ! WRITE(I_NOUT,*) '       ',J,'   ',ZNORM(J)
  ! ENDDO
! ENDIF
DEALLOCATE(ZNORM)
!**************************************************************
IF ( I_MYPROC==1 ) THEN
  OPEN(UNIT=97,FILE='fic_normt',FORM='formatted')
  DO J=1,I_NFLEVG
    WRITE(97,FMT='(2(E24.16)2x)')ZNORM1T(J),ZNORM2T(J)
  ENDDO
  CLOSE(97)
  !**************************************************************
  OPEN(UNIT=97,FILE='fic_normd',FORM='formatted')
  DO J=1,I_NFLEVG
    WRITE(97,FMT='(2(E24.16)2x)')ZNORM1D(J),ZNORM2D(J)
  ENDDO
  CLOSE(97)
  !**************************************************************
  OPEN(UNIT=97,FILE='fic_normv',FORM='formatted')
  DO J=1,I_NFLEVG
    WRITE(97,FMT='(2(E24.16)2x)')ZNORM1V(J),ZNORM2V(J)
  ENDDO
  CLOSE(97)
  !**************************************************************
ENDIF

DEALLOCATE(ZNORM1T)
DEALLOCATE(ZNORM2T)
DEALLOCATE(ZNORM1D)
DEALLOCATE(ZNORM2D)
DEALLOCATE(ZNORM1V)
DEALLOCATE(ZNORM2V)
DEALLOCATE(Z_DATA)
DEALLOCATE(INGRIB)

IF (LHOOK) CALL DR_HOOK('TEST',1,ZHOOK_HANDLE)

!!**************************************
100 CONTINUE
IF(NPROC > 1 .OR. .NOT.LMPOFF ) THEN
  CALL MPL_BARRIER()
  CALL MPL_END
ENDIF
CALL FLUSH(I_NOUT)
!**************************************************************
END PROGRAM TEST
